--- dmesg.old	2008-04-16 15:12:28.000000000 -0400
+++ dmesg	2008-04-16 22:48:56.000000000 -0400
@@ -141,7 +141,7 @@
 PID hash table entries: 4096 (order: 12, 32768 bytes)
 Extended CMOS year: 2000
 TSC calibrated against PM_TIMER
-time.c: Detected 1795.492 MHz processor.
+time.c: Detected 1795.497 MHz processor.
 Console: colour VGA+ 80x25
 console [tty0] enabled
 Checking aperture...
@@ -153,7 +153,7 @@
 CPA: page pool initialized 1 of 1 pages preallocated
 SLUB: Genslabs=13, HWalign=64, Order=0-1, MinObjects=4, CPUs=2, Nodes=1
 hpet clockevent registered
-Calibrating delay using timer specific routine.. 3594.46 BogoMIPS (lpj=1797230)
+Calibrating delay using timer specific routine.. 3594.80 BogoMIPS (lpj=1797402)
 Security Framework initialized
 SELinux:  Initializing.
 SELinux:  Starting in permissive mode
@@ -172,11 +172,11 @@
 using mwait in idle threads.
 ACPI: Core revision 20070126
 Using local APIC timer interrupts.
-APIC timer calibration result 12468682
+APIC timer calibration result 12468731
 Detected 12.468 MHz APIC timer.
 Booting processor 1/2 APIC 0x1
 Initializing CPU#1
-Calibrating delay using timer specific routine.. 3590.83 BogoMIPS (lpj=1795415)
+Calibrating delay using timer specific routine.. 3590.86 BogoMIPS (lpj=1795432)
 CPU: L1 I cache: 32K, L1 D cache: 32K
 CPU: L2 cache: 2048K
 CPU 1/1 -> Node 0
@@ -204,7 +204,7 @@
   domain 1: span 00000000,00000003
    groups: 00000000,00000003
 net_namespace: 1016 bytes
-Time: 19:09:09  Date: 04/16/08
+Time:  2:47:49  Date: 04/17/08
 NET: Registered protocol family 16
 ACPI: ACPI Dock Station Driver 
 ACPI: bus type pci registered
@@ -235,7 +235,7 @@
 Linux Plug and Play Support v0.97 (c) Adam Belay
 pnp: PnP ACPI init
 ACPI: bus type pnp registered
-pnp: PnP ACPI: found 15 devices
+pnp: PnP ACPI: found 14 devices
 ACPI: ACPI bus type pnp unregistered
 usbcore: registered new interface driver usbfs
 usbcore: registered new interface driver hub
@@ -253,40 +253,40 @@
 system 00:05: ioport range 0xc80-0xcaf has been reserved
 system 00:05: ioport range 0xcc0-0xcff could not be reserved
 system 00:08: iomem range 0xfed00000-0xfed003ff has been reserved
-system 00:0b: ioport range 0xcb0-0xcbb has been reserved
-system 00:0b: iomem range 0xfed40000-0xfed44fff could not be reserved
-system 00:0c: ioport range 0x900-0x97f has been reserved
-system 00:0c: ioport range 0x4d0-0x4d1 has been reserved
-system 00:0c: ioport range 0x1000-0x1005 has been reserved
-system 00:0c: ioport range 0x1008-0x100f has been reserved
-system 00:0d: ioport range 0xf400-0xf4fe has been reserved
-system 00:0d: ioport range 0x1006-0x1007 has been reserved
-system 00:0d: ioport range 0x100a-0x1059 could not be reserved
-system 00:0d: ioport range 0x1060-0x107f has been reserved
-system 00:0d: ioport range 0x1080-0x10bf has been reserved
-system 00:0d: ioport range 0x10c0-0x10df has been reserved
-system 00:0d: ioport range 0x1010-0x102f has been reserved
-system 00:0d: ioport range 0x809-0x809 has been reserved
-system 00:0e: iomem range 0x0-0x9efff could not be reserved
-system 00:0e: iomem range 0x9f000-0x9ffff could not be reserved
-system 00:0e: iomem range 0xc0000-0xcffff has been reserved
-system 00:0e: iomem range 0xe0000-0xfffff has been reserved
-system 00:0e: iomem range 0x100000-0xdf6803ff could not be reserved
-system 00:0e: iomem range 0xdf680400-0xdf6fffff could not be reserved
-system 00:0e: iomem range 0xdf700000-0xdf7fffff could not be reserved
-system 00:0e: iomem range 0xdf700000-0xdfefffff could not be reserved
-system 00:0e: iomem range 0xffe00000-0xffffffff could not be reserved
-system 00:0e: iomem range 0xffa00000-0xffbfffff has been reserved
-system 00:0e: iomem range 0xfec00000-0xfec0ffff could not be reserved
-system 00:0e: iomem range 0xfee00000-0xfee0ffff could not be reserved
-system 00:0e: iomem range 0xfed20000-0xfed3ffff could not be reserved
-system 00:0e: iomem range 0xfed45000-0xfed8ffff could not be reserved
-system 00:0e: iomem range 0xfeda0000-0xfeda3fff could not be reserved
-system 00:0e: iomem range 0xfeda4000-0xfeda4fff could not be reserved
-system 00:0e: iomem range 0xfeda5000-0xfeda5fff could not be reserved
-system 00:0e: iomem range 0xfeda6000-0xfeda6fff has been reserved
-system 00:0e: iomem range 0xfed18000-0xfed1bfff could not be reserved
-system 00:0e: iomem range 0xf8000000-0xfbffffff could not be reserved
+system 00:0a: ioport range 0xcb0-0xcbb has been reserved
+system 00:0a: iomem range 0xfed40000-0xfed44fff could not be reserved
+system 00:0b: ioport range 0x900-0x97f has been reserved
+system 00:0b: ioport range 0x4d0-0x4d1 has been reserved
+system 00:0b: ioport range 0x1000-0x1005 has been reserved
+system 00:0b: ioport range 0x1008-0x100f has been reserved
+system 00:0c: ioport range 0xf400-0xf4fe has been reserved
+system 00:0c: ioport range 0x1006-0x1007 has been reserved
+system 00:0c: ioport range 0x100a-0x1059 could not be reserved
+system 00:0c: ioport range 0x1060-0x107f has been reserved
+system 00:0c: ioport range 0x1080-0x10bf has been reserved
+system 00:0c: ioport range 0x10c0-0x10df has been reserved
+system 00:0c: ioport range 0x1010-0x102f has been reserved
+system 00:0c: ioport range 0x809-0x809 has been reserved
+system 00:0d: iomem range 0x0-0x9efff could not be reserved
+system 00:0d: iomem range 0x9f000-0x9ffff could not be reserved
+system 00:0d: iomem range 0xc0000-0xcffff has been reserved
+system 00:0d: iomem range 0xe0000-0xfffff has been reserved
+system 00:0d: iomem range 0x100000-0xdf6803ff could not be reserved
+system 00:0d: iomem range 0xdf680400-0xdf6fffff could not be reserved
+system 00:0d: iomem range 0xdf700000-0xdf7fffff could not be reserved
+system 00:0d: iomem range 0xdf700000-0xdfefffff could not be reserved
+system 00:0d: iomem range 0xffe00000-0xffffffff could not be reserved
+system 00:0d: iomem range 0xffa00000-0xffbfffff has been reserved
+system 00:0d: iomem range 0xfec00000-0xfec0ffff could not be reserved
+system 00:0d: iomem range 0xfee00000-0xfee0ffff could not be reserved
+system 00:0d: iomem range 0xfed20000-0xfed3ffff could not be reserved
+system 00:0d: iomem range 0xfed45000-0xfed8ffff could not be reserved
+system 00:0d: iomem range 0xfeda0000-0xfeda3fff could not be reserved
+system 00:0d: iomem range 0xfeda4000-0xfeda4fff could not be reserved
+system 00:0d: iomem range 0xfeda5000-0xfeda5fff could not be reserved
+system 00:0d: iomem range 0xfeda6000-0xfeda6fff has been reserved
+system 00:0d: iomem range 0xfed18000-0xfed1bfff could not be reserved
+system 00:0d: iomem range 0xf8000000-0xfbffffff could not be reserved
 PCI: Bridge: 0000:00:1c.0
   IO window: disabled.
   MEM window: disabled.
@@ -328,7 +328,7 @@
  it is
 Freeing initrd memory: 6144k freed
 audit: initializing netlink socket (disabled)
-type=2000 audit(1208372949.998:1): initialized
+type=2000 audit(1208400469.310:1): initialized
 Total HugeTLB memory allocated, 0
 VFS: Disk quotas dquot_6.5.1
 Dquot-cache hash table entries: 512 (order 0, 4096 bytes)
@@ -369,7 +369,7 @@
 ACPI: ACPI0007:01 is registered as cooling_device1
 ACPI: Processor [CPU1] (supports 8 throttling states)
 ACPI: LNXTHERM:01 is registered as thermal_zone0
-ACPI: Thermal Zone [THM] (57 C)
+ACPI: Thermal Zone [THM] (25 C)
 hpet_resources: 0xfed00000 is busy
 Non-volatile memory driver v1.2
 Linux agpgart interface v0.103
@@ -408,8 +408,9 @@
 NET: Registered protocol family 1
 NET: Registered protocol family 17
 registered taskstats version 1
-  Magic number: 4:820:192
-  hash matches device device:1e
+  Magic number: 4:708:763
+  hash matches drivers/base/power/main.c:143
+  hash matches device serio1
 Freeing unused kernel memory: 352k freed
 Write protecting the kernel read-only data: 1116k
 ACPI: PCI Interrupt 0000:00:1a.7[C] -> GSI 22 (level, low) -> IRQ 22
@@ -419,7 +420,6 @@
 ehci_hcd 0000:00:1a.7: debug port 1
 PCI: cache line size of 32 is not supported by device 0000:00:1a.7
 ehci_hcd 0000:00:1a.7: irq 22, io mem 0xfed1c400
-Clocksource tsc unstable (delta = -237565876 ns)
 ehci_hcd 0000:00:1a.7: USB 2.0 started, EHCI 1.00, driver 10 Dec 2004
 usb usb1: configuration #1 chosen from 1 choice
 hub 1-0:1.0: USB hub found
@@ -440,6 +440,7 @@
 usb usb2: configuration #1 chosen from 1 choice
 hub 2-0:1.0: USB hub found
 hub 2-0:1.0: 6 ports detected
+Clocksource tsc unstable (delta = -397624873 ns)
 usb usb2: New USB device found, idVendor=1d6b, idProduct=0002
 usb usb2: New USB device strings: Mfr=3, Product=2, SerialNumber=1
 usb usb2: Product: EHCI Host Controller
@@ -455,7 +456,6 @@
 usb usb3: configuration #1 chosen from 1 choice
 hub 3-0:1.0: USB hub found
 hub 3-0:1.0: 2 ports detected
-usb 1-3: new high speed USB device using ehci_hcd and address 2
 input: PS/2 Mouse as /devices/platform/i8042/serio1/input/input2
 usb usb3: New USB device found, idVendor=1d6b, idProduct=0001
 usb usb3: New USB device strings: Mfr=3, Product=2, SerialNumber=1
@@ -471,9 +471,6 @@
 hub 4-0:1.0: USB hub found
 hub 4-0:1.0: 2 ports detected
 input: AlpsPS/2 ALPS GlidePoint as /devices/platform/i8042/serio1/input/input3
-usb 1-3: configuration #1 chosen from 1 choice
-hub 1-3:1.0: USB hub found
-hub 1-3:1.0: 4 ports detected
 usb usb4: New USB device found, idVendor=1d6b, idProduct=0001
 usb usb4: New USB device strings: Mfr=3, Product=2, SerialNumber=1
 usb usb4: Product: UHCI Host Controller
@@ -487,8 +484,6 @@
 usb usb5: configuration #1 chosen from 1 choice
 hub 5-0:1.0: USB hub found
 hub 5-0:1.0: 2 ports detected
-usb 1-3: New USB device found, idVendor=413c, idProduct=0058
-usb 1-3: New USB device strings: Mfr=0, Product=0, SerialNumber=0
 usb usb5: New USB device found, idVendor=1d6b, idProduct=0001
 usb usb5: New USB device strings: Mfr=3, Product=2, SerialNumber=1
 usb usb5: Product: UHCI Host Controller
@@ -530,34 +525,39 @@
 scsi1 : ata_piix
 ata1: PATA max UDMA/100 cmd 0x1f0 ctl 0x3f6 bmdma 0x6fa0 irq 14
 ata2: PATA max UDMA/100 cmd 0x170 ctl 0x376 bmdma 0x6fa8 irq 15
+usb 7-1: new full speed USB device using uhci_hcd and address 2
+usb 7-1: configuration #1 chosen from 1 choice
+hub 7-1:1.0: USB hub found
+hub 7-1:1.0: 4 ports detected
 ata1.00: ATAPI: CD-RW/DVD-ROM DW224EV, D.CF, max UDMA/33
-usb 1-3.1: new high speed USB device using ehci_hcd and address 3
+usb 7-1: New USB device found, idVendor=0b97, idProduct=7761
+usb 7-1: New USB device strings: Mfr=0, Product=0, SerialNumber=0
 ata1.00: configured for UDMA/33
 ata2: port disabled. ignoring.
 scsi 0:0:0:0: CD-ROM            TEAC     CDRWDVD DW224EV  D.CF PQ: 0 ANSI: 5
 ACPI: PCI Interrupt 0000:00:1f.2[B] -> GSI 17 (level, low) -> IRQ 17
 ata_piix 0000:00:1f.2: MAP [ P0 P2 P1 P3 ]
-usb 1-3.1: configuration #1 chosen from 1 choice
-hub 1-3.1:1.0: USB hub found
-hub 1-3.1:1.0: 4 ports detected
 PCI: Setting latency timer of device 0000:00:1f.2 to 64
 scsi2 : ata_piix
 scsi3 : ata_piix
 ata3: SATA max UDMA/133 cmd 0x6eb0 ctl 0x6eb8 bmdma 0x6ee0 irq 17
 ata4: SATA max UDMA/133 cmd 0x6ec0 ctl 0x6ec8 bmdma 0x6ee8 irq 17
-usb 1-3.1: New USB device found, idVendor=0424, idProduct=2504
-usb 1-3.1: New USB device strings: Mfr=0, Product=0, SerialNumber=0
-usb 7-1: new full speed USB device using uhci_hcd and address 2
-usb 7-1: configuration #1 chosen from 1 choice
-hub 7-1:1.0: USB hub found
-hub 7-1:1.0: 4 ports detected
+usb 7-2: new full speed USB device using uhci_hcd and address 3
+usb 7-2: configuration #1 chosen from 1 choice
+usb 7-2: New USB device found, idVendor=0483, idProduct=2016
+usb 7-2: New USB device strings: Mfr=1, Product=2, SerialNumber=0
+usb 7-2: Product: Biometric Coprocessor
+usb 7-2: Manufacturer: STMicroelectronics
+usb 7-1.2: new full speed USB device using uhci_hcd and address 4
+usb 7-1.2: configuration #1 chosen from 1 choice
+usb 7-1.2: New USB device found, idVendor=0b97, idProduct=7772
+usb 7-1.2: New USB device strings: Mfr=1, Product=2, SerialNumber=0
+usb 7-1.2: Product: O2Micro CCID SC Reader
+usb 7-1.2: Manufacturer: O2
 ata3: SATA link up 1.5 Gbps (SStatus 113 SControl 300)
 ata3.00: ATA-7: Hitachi HTS541680J9SA00, SB2OC7KP, max UDMA/100
 ata3.00: 156301488 sectors, multi 8: LBA48 NCQ (depth 0/32)
 ata3.00: configured for UDMA/100
-usb 7-1: New USB device found, idVendor=0b97, idProduct=7761
-usb 7-1: New USB device strings: Mfr=0, Product=0, SerialNumber=0
-usb 7-2: new full speed USB device using uhci_hcd and address 3
 ata4: SATA link down (SStatus 0 SControl 0)
 scsi 2:0:0:0: Direct-Access     ATA      Hitachi HTS54168 SB2O PQ: 0 ANSI: 5
 sd 2:0:0:0: [sda] 156301488 512-byte hardware sectors (80026 MB)
@@ -570,29 +570,9 @@
 sd 2:0:0:0: [sda] Write cache: enabled, read cache: enabled, doesn't support DPO or FUA
  sda: sda1 sda2 sda3
 sd 2:0:0:0: [sda] Attached SCSI disk
-usb 7-2: configuration #1 chosen from 1 choice
-usb 7-2: New USB device found, idVendor=0483, idProduct=2016
-usb 7-2: New USB device strings: Mfr=1, Product=2, SerialNumber=0
-usb 7-2: Product: Biometric Coprocessor
-usb 7-2: Manufacturer: STMicroelectronics
-usb 7-1.2: new full speed USB device using uhci_hcd and address 4
-usb 7-1.2: configuration #1 chosen from 1 choice
-usb 7-1.2: New USB device found, idVendor=0b97, idProduct=7772
-usb 7-1.2: New USB device strings: Mfr=1, Product=2, SerialNumber=0
-usb 7-1.2: Product: O2Micro CCID SC Reader
-usb 7-1.2: Manufacturer: O2
 device-mapper: uevent: version 1.0.3
 device-mapper: ioctl: 4.13.0-ioctl (2007-10-18) initialised: dm-devel@redhat.com
-EXT3-fs: INFO: recovery required on readonly filesystem.
-EXT3-fs: write access will be enabled during recovery.
 kjournald starting.  Commit interval 5 seconds
-EXT3-fs: dm-0: orphan cleanup on readonly fs
-ext3_orphan_cleanup: deleting unreferenced inode 196627
-ext3_orphan_cleanup: deleting unreferenced inode 2986368
-ext3_orphan_cleanup: deleting unreferenced inode 2327330
-ext3_orphan_cleanup: deleting unreferenced inode 1975008
-EXT3-fs: dm-0: 4 orphan inodes deleted
-EXT3-fs: recovery complete.
 EXT3-fs: mounted filesystem with ordered data mode.
 SELinux:8192 avtab hash slots allocated. Num of rules:172102
 SELinux:8192 avtab hash slots allocated. Num of rules:172102
@@ -619,28 +599,27 @@
 SELinux: initialized (dev rootfs, type rootfs), uses genfs_contexts
 SELinux: initialized (dev sysfs, type sysfs), uses genfs_contexts
 SELinux: policy loaded with handle_unknown=allow
-type=1403 audit(1208373024.834:2): policy loaded auid=4294967295 ses=4294967295
+type=1403 audit(1208400480.806:2): policy loaded auid=4294967295 ses=4294967295
 scsi 0:0:0:0: Attached scsi generic sg0 type 5
 sd 2:0:0:0: Attached scsi generic sg1 type 0
-iTCO_vendor_support: vendor-support=0
-iTCO_wdt: Intel TCO WatchDog Timer Driver v1.02 (26-Jul-2007)
-iTCO_wdt: Found a ICH8M TCO device (Version=2, TCOBASE=0x1060)
-iTCO_wdt: initialized. heartbeat=30 sec (nowayout=0)
 Driver 'sr' needs updating - please use bus_type methods
 sr0: scsi3-mmc drive: 24x/24x writer cd/rw xa/form2 cdda tray
 Uniform CD-ROM driver Revision: 3.20
 sr 0:0:0:0: Attached scsi CD-ROM sr0
-dcdbas dcdbas: Dell Systems Management Base Driver (version 5.6.0-3.2)
 tg3.c:v3.90 (April 12, 2008)
 ACPI: PCI Interrupt 0000:09:00.0[A] -> GSI 17 (level, low) -> IRQ 17
 PCI: Setting latency timer of device 0000:09:00.0 to 64
 eth0: Tigon3 [partno(BCM95755m) rev a002 PHY(5755)] (PCI Express) 10/100/1000Base-T Ethernet 00:1c:23:14:59:ef
 eth0: RXcsums[1] LinkChgREG[0] MIirq[0] ASF[0] WireSpeed[1] TSOcap[1]
 eth0: dma_rwctrl[76180000] dma_mask[64-bit]
-ACPI: PCI Interrupt 0000:00:1f.3[B] -> GSI 17 (level, low) -> IRQ 17
-parport_pc 00:0a: reported by Plug and Play ACPI
-parport0: PC-style at 0x378 (0x778), irq 7 [PCSPP,TRISTATE]
+dcdbas dcdbas: Dell Systems Management Base Driver (version 5.6.0-3.2)
+iTCO_vendor_support: vendor-support=0
+iTCO_wdt: Intel TCO WatchDog Timer Driver v1.02 (26-Jul-2007)
+iTCO_wdt: Found a ICH8M TCO device (Version=2, TCOBASE=0x1060)
+iTCO_wdt: initialized. heartbeat=30 sec (nowayout=0)
+ACPI: AC Adapter [AC] (off-line)
 input: PC Speaker as /devices/platform/pcspkr/input/input4
+ACPI: PCI Interrupt 0000:00:1f.3[B] -> GSI 17 (level, low) -> IRQ 17
 iwl3945: Intel(R) PRO/Wireless 3945ABG/BG Network Connection driver for Linux, 1.2.26kds
 iwl3945: Copyright(c) 2003-2008 Intel Corporation
 ACPI: PCI Interrupt 0000:0c:00.0[A] -> GSI 17 (level, low) -> IRQ 17
@@ -648,21 +627,16 @@
 iwl3945: Detected Intel Wireless WiFi Link 3945ABG
 iwl3945: Tunable channels: 11 802.11bg, 13 802.11a channels
 phy0: Selected rate control algorithm 'iwl-3945-rs'
-ACPI: Battery Slot [BAT0] (battery present)
-ACPI: Battery Slot [BAT1] (battery absent)
-ppdev: user-space parallel port driver
 input: Lid Switch as /devices/LNXSYSTM:00/device:00/PNP0C0D:00/input/input5
 ACPI: Lid Switch [LID]
 input: Power Button (CM) as /devices/LNXSYSTM:00/device:00/PNP0C0C:00/input/input6
 ACPI: Power Button (CM) [PBTN]
 input: Sleep Button (CM) as /devices/LNXSYSTM:00/device:00/PNP0C0E:00/input/input7
 ACPI: Sleep Button (CM) [SBTN]
-ACPI: AC Adapter [AC] (on-line)
-ACPI: WMI: Mapper loaded
+ACPI: Battery Slot [BAT0] (battery present)
+ACPI: Battery Slot [BAT1] (battery absent)
 [drm] Initialized drm 1.1.0 20060810
-ACPI: PCI interrupt for device 0000:0c:00.0 disabled
-ACPI: PCI Interrupt 0000:03:01.4[A] -> GSI 19 (level, low) -> IRQ 19
-firewire_ohci: Added fw-ohci device 0000:03:01.4, OHCI version 1.10
+ACPI: WMI: Mapper loaded
 ACPI: \_SB_.PCI0.IDE0.SEC0.MAST: found ejectable bay
 ACPI: \_SB_.PCI0.IDE0.SEC0.MAST: Adding notify handler
 ACPI: Error installing bay notify handler
@@ -671,7 +645,6 @@
 ACPI: \_SB_.PCI0.IDE1.PRI_.MAST: Adding notify handler
 ACPI: Error installing bay notify handler
 ACPI: Bay [\_SB_.PCI0.IDE1.PRI_.MAST] Added
-firewire_core: created device fw0: GUID 364fc0001593e181, S400
 ACPI: PCI Interrupt 0000:00:02.0[A] -> GSI 16 (level, low) -> IRQ 16
 PCI: Setting latency timer of device 0000:00:02.0 to 64
 [drm] Initialized i915 1.12.0 20071122 on minor 0
@@ -681,6 +654,10 @@
 ACPI: Video Device [VID1] (multi-head: yes  rom: no  post: no)
 input: Video Bus as /devices/LNXSYSTM:00/device:00/PNP0A03:00/device:3c/input/input10
 ACPI: Video Device [VID2] (multi-head: yes  rom: no  post: no)
+ACPI: PCI interrupt for device 0000:0c:00.0 disabled
+ACPI: PCI Interrupt 0000:03:01.4[A] -> GSI 19 (level, low) -> IRQ 19
+firewire_ohci: Added fw-ohci device 0000:03:01.4, OHCI version 1.10
+firewire_core: created device fw0: GUID 364fc0001593e181, S400
 ACPI: PCI Interrupt 0000:00:1b.0[A] -> GSI 21 (level, low) -> IRQ 21
 PCI: Setting latency timer of device 0000:00:1b.0 to 64
 ALSA sound/pci/hda/hda_intel.c:1810: chipset global capabilities = 0x4401